;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
;;
;; Update player ship
;;

Update_Player_ship:
				moveq	#0,r0
				movei	#ship_obj,r1
				movei	#ship_x,r2
				load	(r1),r1					; r1=pointer to ship object
				movei	#ship_y,r3
				loadw	(r2),r2					; r2=ship x
				movei	#map_x_pos,r4
				loadw	(r3),r3					; r3=ship y
				movei	#ship_anim,r30
				loadw	(r4),r4					; r4=map X position
;				movei	#ship_anim_tab,r14
				load	(r30),r0				; animation frame
				movei	#left_marg,r5
				sub		r4,r2					; ship x into screen x
;				shlq	#2,r0
;				load	(r14+r0),r0				; pointer to ship GFX
				loadw	(r5),r20				; left_margin (PAL/NTSC)
				movei	#%111111111111,r10
				movei	#%1111111111,r11
				add		r20,r2
				movei	#$c007,r12
				movei	#$f000,r13
				movei	#%00000000000000000000011111111111,r14
				and		r10,r2					; mask x
				and		r11,r3					; mask y
				load	(r1),r30				; get LONG with GFX pointer
				and		r14,r30					; mask out old one
				shlq	#8,r0					; shift new pointer to correct pos
				or		r0,r30					; store
				store	r30,(r1)				; and write back to OL
				addq	#6,r1					; offset to y
				loadw	(r1),r30				; get WORD with Y in
				and		r12,r30					; mask out old one
				add		r3,r3					; double current y (half scans)
				shlq	#3,r3					; shift to correct position
				or		r3,r30					; store
				storew	r30,(r1)				; and write back to OL
				addq	#8,r1					; offset to x
				loadw	(r1),r30				; get WORD with X in
				and		r13,r30					; mask out old one
				or		r2,r30					; store
				storew	r30,(r1)				; and write back to OL

; update paralax layer
				movei	#py_start,r0
				movei	#underlay_obj,r1
				load	(r0),r0					; bitmap address
				load	(r1),r1					; object address
				shlq	#8,r0
				load	(r1),r30
				movei	#px_start,r2
				moveq	#4,r3
				load	(r2),r2					; r2=X
				and		r14,r30
				add		r20,r2
				or		r0,r30
				and		r10,r2
				store	r30,(r1)				; store new bitmap address
				addq	#6,r1
				loadw	(r1),r30
				and		r12,r30
				add		r3,r3
				shlq	#7,r3
				or		r3,r30
				storew	r30,(r1)
				addq	#8,r1
				loadw	(r1),r30
				and		r13,r30
				or		r2,r30
				storew	r30,(r1)
				
				
stop_gpu:      	moveq   #0,r0                   ; Stop GPU
                movei   #G_CTRL,r1
                store   r0,(r1)
                nop
                nop


				