setup_scoreboard:
			bsr		info_init
			move.l	#'0000',score_t						; BCD zero score
			move.l	#'0000',score_t+4
			move.l	$1108,hiscore_t
			move.l	$110c,hiscore_t+4
				
update_scoreboard:
			move.l	scorebuf,a0
			move.l	#-1,(a0)		; terminate table

			move.l	#'0000',d7
			lea		score_t,a0		; ascii to unpacked bcd the scoreboard
			lea		hiscore_t,a1
			sub.l	d7,(a0)+
			sub.l	d7,(a0)
			sub.l	d7,(a1)+
			sub.l	d7,(a1)
			
			moveq	#0,d4
			lea		score_t,a0

			or.b	(a0)+,d4		; load BCD score into D4
			rol.l	#4,d4
			or.b	(a0)+,d4		
			rol.l	#4,d4
			or.b	(a0)+,d4		
			rol.l	#4,d4
			or.b	(a0)+,d4		
			rol.l	#4,d4
			or.b	(a0)+,d4		
			rol.l	#4,d4
			or.b	(a0)+,d4		
			rol.l	#4,d4
			or.b	(a0)+,d4		
			rol.l	#4,d4
			or.b	(a0)+,d4		

			moveq	#0,d5
			lea		hiscore_t,a0

			or.b	(a0)+,d5		; load BCD hiscore into D5
			rol.l	#4,d5
			or.b	(a0)+,d5		
			rol.l	#4,d5
			or.b	(a0)+,d5		
			rol.l	#4,d5
			or.b	(a0)+,d5		
			rol.l	#4,d5
			or.b	(a0)+,d5		
			rol.l	#4,d5
			or.b	(a0)+,d5		
			rol.l	#4,d5
			or.b	(a0)+,d5		
			rol.l	#4,d5
			or.b	(a0)+,d5
			
			move.l	d4,bcd_score	; 4 bytes / 8 digits
			
			lea		s_buffer,a0
.sc_add:	move.l	(a0),d0			; get BCD value to add
			bmi		.end_buff		; if -ve then end
			
			sub.l	d7,(a0)
			
			moveq	#0,d4			; convert the addition value to packed BCD
			or.b	(a0)+,d4
			rol.l	#4,d4
			or.b	(a0)+,d4
			rol.l	#4,d4
			or.b	(a0)+,d4
			rol.l	#4,d4
			or.b	(a0)+,d4
			
			move.l	d4,bcd_add		; 2 bytes / 4 digits (leading 2 bytes=0)

			lea		bcd_add+4,a5	; do the BCD addition
			andi	#$ef,ccr
			lea		bcd_score+4,a6
			abcd	-(a5),-(a6)
			abcd	-(a5),-(a6)
			abcd	-(a5),-(a6)
			abcd	-(a5),-(a6)
			bra		.sc_add
			
.end_buff:	move.l	#s_buffer,scorebuf

			move.l	bcd_score,d0	; convert the score from packed to unpacked bcd

			cmp.l	d0,d5
			bgt		.no_new_hiscore

			lea		hiscore_t+8,a0
			move.l	d0,-(a7)
			move.b	d0,-(a0)
			and.b	#$f,(a0)
			ror.l	#4,d0
			move.b	d0,-(a0)
			and.b	#$f,(a0)
			ror.l	#4,d0
			move.b	d0,-(a0)
			and.b	#$f,(a0)
			ror.l	#4,d0
			move.b	d0,-(a0)
			and.b	#$f,(a0)
			ror.l	#4,d0
			move.b	d0,-(a0)
			and.b	#$f,(a0)
			ror.l	#4,d0
			move.b	d0,-(a0)
			and.b	#$f,(a0)
			ror.l	#4,d0
			move.b	d0,-(a0)
			and.b	#$f,(a0)
			ror.l	#4,d0
			move.b	d0,-(a0)
			and.b	#$f,(a0)
			move.l	(a7)+,d0
			
.no_new_hiscore:
			lea		score_t+8,a0
			move.b	d0,-(a0)
			and.b	#$f,(a0)
			ror.l	#4,d0
			move.b	d0,-(a0)
			and.b	#$f,(a0)
			ror.l	#4,d0
			move.b	d0,-(a0)
			and.b	#$f,(a0)
			ror.l	#4,d0
			move.b	d0,-(a0)
			and.b	#$f,(a0)
			ror.l	#4,d0
			move.b	d0,-(a0)
			and.b	#$f,(a0)
			ror.l	#4,d0
			move.b	d0,-(a0)
			and.b	#$f,(a0)
			ror.l	#4,d0
			move.b	d0,-(a0)
			and.b	#$f,(a0)
			ror.l	#4,d0
			move.b	d0,-(a0)
			and.b	#$f,(a0)
						
			lea		hiscore_t,a1
			add.l	d7,(a1)+
			add.l	d7,(a1)
			lea		score_t,a1
			add.l	d7,(a1)+
			add.l	d7,(a1)
			
			lea		score_t,a0
			lea		score_scr,a1
			move.l	(a0)+,(a1)+
			move.l	(a0)+,(a1)+

			lea		hiscore_t,a0
			lea		hiscore_scr,a1
			move.l	(a0)+,(a1)+
			move.l	(a0)+,(a1)+
			
			lea		score_txt,a1
			bsr		info
			lea		hiscore_txt,a1
			bsr		info
			
			move.l	hiscore_t,$1108
			move.l	hiscore_t+4,$110c
			
			rts

bcd_score:	dc.l 	0
bcd_add:	dc.l 	0
			
			.phrase
scorebuf:	dc.l	s_buffer
s_buffer:	dc.l	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
			dc.l	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
			dc.l	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
			
vlines		equ		40

			dc.b 0,0,0,0
score_add:	dc.b "0000"

score_t:	dc.b "00000000"
hiscore_t:	dc.b "00000000"

	
score_txt:	dc.l 0
score_scr:	dc.b "00000000 ",-1
			even
			
hiscore_txt:dc.l 40*11			
hiscore_scr:dc.b "00000000",-1
			.phrase
			
score_bcd:	dc.b 0000
hscore_bcd:	dc.b 0000

				.phrase
display_obj:	dc.l	0
				
				.phrase
display_bmp0:
				.rept	40*18
				.dc.b	0
				.endr
				.phrase
				
font_x:
			incbin "JAGBMPS/ATARISYS.FNT"
		.even
		
ascii:	
		.rept 40*3
		dc.l 0
		endr

info_init:
		lea font_x(pc),a0			; Font offsets for plotter
		move.l a0,d0
		move.l d0,d1
		move.l d0,d2
		add.l #40*9,d1
		add.l #40*18,d2
		lea ascii,a1
		move.w #39,d3
.adder:
		move.l d0,(a1)
		move.l d1,160(a1)
		move.l d2,320(a1)
		addq.l #1,d0
		addq.l #1,d1
		addq.l #1,d2
		lea 4(a1),a1
		dbra d3,.adder
		rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Text plotting routine
;;
;; call with a1 pointing at text
;;       

info:	lea display_bmp0,a0
printer:
		add.l (a1)+,a0
		lea next_add,a3
		move.l a0,(a3)
.loop:	moveq.l #0,d0
		move.b (a1)+,d0
		bpl.s .write
		cmp.b #-1,d0
		beq.s .wrap
.nextline:
		move.l (a3),a0
		add.l #40*9,a0
		move.l a0,(a3)
		bra.s .loop
.wrap:
		rts
.write:
		sub.b #' ',d0
		add d0,d0
		add d0,d0
		lea ascii,a2
		move.l (a2,d0),a2
		bsr.s .plotit
		bra .loop
.plotit:	
		move.b (a2),(a0)
		move.b	40(a2),40(a0)
		move.b	80(a2),80(a0)
		move.b	120(a2),120(a0)
		move.b	160(a2),160(a0)
		move.b	200(a2),200(a0)
		move.b	240(a2),240(a0)
		move.b	280(a2),280(a0)
		add.l 	#1,a0
		rts
		
next_add:	dc.l	0
