;;;;;;;;;;;;;;
;;;;;;;;;;;;;; BULLET TYPE DATA
;;;;;;;;;;;;;;

new_bullet_type:	.dc.l	0
new_bullet_x:		.dc.l	0
new_bullet_y:		.dc.l	0
new_bullet_owner:	.dc.l	0

bullet_lookup:		.dc.l	P_00,B_01,B_02,B_03,B_04,B_05,P_01,P_02,P_03,P_04
					.dc.l	B_06,B_07,B_08
					.dc.l	L_00,S_00
					
bg equ 32
					
;;
;; Bullet Type 0 (Player weapon)

L_00:			.dc.l	laser00_bmp			; pointer to gfx					; player bullet (l1)
				.dc.l	1					; frames in bullet animation
				.dc.l	0					; number of bullets in spread
				.dc.l	player_laser_00	; pointer to bullet addition table

S_00:			.dc.l	bullet00_bmp		; pointer to gfx					; player bullet (l1)
				.dc.l	1					; frames in bullet animation
				.dc.l	1					; number of bullets in spread
				.dc.l	player_sidesh_00	; pointer to bullet addition table


P_00:			.dc.l	bullet00_bmp		; pointer to gfx					; player bullet (l1)
				.dc.l	1					; frames in bullet animation
				.dc.l	0					; number of bullets in spread
				.dc.l	player_pattern_00	; pointer to bullet addition table
P_01:			.dc.l	bullet00_bmp		; pointer to gfx					; player bullet (l2)
				.dc.l	1					; frames in bullet animation
				.dc.l	1					; number of bullets in spread
				.dc.l	player_pattern_01	; pointer to bullet addition table
P_02:			.dc.l	bullet00_bmp		; pointer to gfx					; player bullet (l3)
				.dc.l	1					; frames in bullet animation
				.dc.l	2					; number of bullets in spread
				.dc.l	player_pattern_02	; pointer to bullet addition table
P_03:			.dc.l	bullet00_bmp		; pointer to gfx					; player bullet (l4)
				.dc.l	1					; frames in bullet animation
				.dc.l	4					; number of bullets in spread
				.dc.l	player_pattern_03	; pointer to bullet addition table	
P_04:			.dc.l	bullet00_bmp		; pointer to gfx					; player bullet (l5)
				.dc.l	1					; frames in bullet animation
				.dc.l	6					; number of bullets in spread
				.dc.l	player_pattern_04	; pointer to bullet addition table
				
B_01:			.dc.l	bullet00_bmp+(bg*3)	; pointer to gfx
				.dc.l	1					; frames in bullet animation
				.dc.l	1					; number of bullets in spread
				.dc.l	bullet_pattern_01	; pointer to bullet addition table
				
B_02:			.dc.l	bullet00_bmp+(bg*3)	; pointer to gfx
				.dc.l	1					; frames in bullet animation
				.dc.l	0					; number of bullets in spread
				.dc.l	bullet_pattern_02	; pointer to bullet addition table

B_03:			.dc.l	bullet00_bmp+(bg*4)	; pointer to gfx
				.dc.l	1					; frames in bullet animation
				.dc.l	1					; number of bullets in spread 
				.dc.l	bullet_pattern_03	; pointer to bullet addition table

B_04:			.dc.l	bullet00_bmp+(bg*3)	; pointer to gfx
				.dc.l	1					; frames in bullet animation
				.dc.l	1					; number of bullets in spread
				.dc.l	bullet_pattern_04	; pointer to bullet addition table

B_05:			.dc.l	bullet00_bmp+(bg*2)	; pointer to gfx
				.dc.l	1					; frames in bullet animation
				.dc.l	7					; number of bullets in spread
				.dc.l	bullet_pattern_05	; pointer to bullet addition table

B_06:			.dc.l	bullet00_bmp+(bg*1)	; pointer to gfx
				.dc.l	1					; frames in bullet animation
				.dc.l	0					; number of bullets in spread
				.dc.l	b_turret_left		; pointer to bullet addition table

B_07:			.dc.l	bullet00_bmp+(bg*3)	; pointer to gfx
				.dc.l	1					; frames in bullet animation
				.dc.l	0					; number of bullets in spread
				.dc.l	b_turret_right		; pointer to bullet addition table

B_08:			.dc.l 	bullet00_bmp+(bg*5)	; pointer to gfx
				.dc.l	1					; frames in bullet animation
				.dc.l	99					; number of bullets in spread
				.dc.l	homing_pattern		; pointer to bullet addition table
				
homing_pattern:		.dc.l	0,0				
				
b_turret_left:		.dc.l	1,-2
					
b_turret_right:		.dc.l	-1,-2

player_laser_00:	.dc.l	0,4

player_sidesh_00:	.dc.l	-5,0
					.dc.l	5,0
	
player_pattern_00:	.dc.l	0,4
					
player_pattern_01:	.dc.l	-2,4				; unused (DUALSHOT replaced it)
					.dc.l	2,4
					
player_pattern_02:	.dc.l	0,4
					.dc.l	-1,4				; .dc.l	-2,4
					.dc.l	1,4					; .dc.l	2,4
					
player_pattern_03:	.dc.l	0,4
					.dc.l	-1,4				; .dc.l	-2,4
					.dc.l	1,4					; .dc.l	2,4
					.dc.l	-2,4				; .dc.l	-4,4
					.dc.l	2,4					; .dc.l	4,4

player_pattern_04:	.dc.l	0,4
					.dc.l	-1,4				; .dc.l	-2,4
					.dc.l	1,4					; .dc.l	2,4
					.dc.l	-2,4				; .dc.l	-4,4
					.dc.l	2,4					; .dc.l	4,4
					.dc.l	-3,4				; .dc.l	-6,4
					.dc.l	3,4					; .dc.l	6,4
					
bullet_pattern_01:	.dc.l	0,-4
					.dc.l	0,-6
					
bullet_pattern_02:	.dc.l	0,-4

bullet_pattern_03:	.dc.l	-1,-1
					.dc.l	1,-1
					
bullet_pattern_04:	.dc.l	-1,-3
					.dc.l	1,-3
					
bullet_pattern_05:	.dc.l	2,2
					.dc.l	2,-2
					.dc.l	-2,2
					.dc.l	-2,-2
					.dc.l	0,2
					.dc.l	0,-2
					.dc.l	2,0
					.dc.l	-2,0
					




