;;
;; Equates
;;

;; samples equates
;;

dubmood1_len			equ	98690
alerted_mod_len			equ 317216
ambush_mod_len			equ 121192
enginest_mod_len		equ 100366
one_len					equ	16688			; in
two_len					equ	20807			; in
three_len				equ	17892			; in
apd_len					equ	36823			; in
apt_len					equ	31846			; in
badmood_len				equ	63498			; in
blaster_upgrade_len		equ	21107			; in
cheat_len				equ	21982	
checkpoint_len			equ	16300			; in
complete_len			equ	23335			; in	
explode_len				equ	17143			; in
fastgun_len				equ	3578			; in
feedme_len				equ	18919			; in
game_over_len			equ	13845			; in
get_ready_len			equ 11799			; in
hiscore_len				equ	16508
jack_len				equ	5677			; in
laser_deactivated_len	equ	22156			; in
laser_upgrade_len		equ	23699			; in
life_len				equ	17269			; in
shield_len				equ	10731			; in
shield_activated_len	equ	25156			; in
shield_deactivated_len	equ	28502			; in
shield_reduction_len	equ	23120			; in
shipdead_len			equ	12501			; in
sideshot_len			equ	15878			; in
smartbomb_upgrade_len	equ	13454			; in
smartbomb_fire_len		equ	11802			; in

;; samples offsets
;;

dubmood1_off			equ	0
alerted_mod_off			equ	dubmood1_off+dubmood1_len
ambush_mod_off			equ	alerted_mod_off+alerted_mod_len
enginest_mod_off		equ	ambush_mod_off+ambush_mod_len
one_off					equ	enginest_mod_off+enginest_mod_len
two_off					equ	one_off+one_len
three_off				equ	two_off+two_len
apd_off					equ	three_off+three_len
apt_off					equ	apd_off+apd_len
badmood_off				equ	apt_off+apt_len
blaster_upgrade_off		equ	badmood_off+badmood_len
cheat_off				equ	blaster_upgrade_off+blaster_upgrade_len
checkpoint_off			equ	cheat_off+cheat_len
complete_off			equ	checkpoint_off+checkpoint_len
explode_off				equ	complete_off+complete_len
fastgun_off				equ	explode_off+explode_len
feedme_off				equ	fastgun_off+fastgun_len
game_over_off			equ	feedme_off+feedme_len
get_ready_off			equ	game_over_off+game_over_len
hiscore_off				equ	get_ready_off+get_ready_len
jack_off				equ	hiscore_off+hiscore_len
laser_deactivated_off	equ	jack_off+jack_len
laser_upgrade_off		equ	laser_deactivated_off+laser_deactivated_len
life_off				equ	laser_upgrade_off+laser_upgrade_len
shield_off				equ	life_off+life_len
shield_activated_off	equ	shield_off+shield_len
shield_deactivated_off	equ	shield_activated_off+shield_activated_len
shield_reduction_off	equ	shield_deactivated_off+shield_deactivated_len
shipdead_off			equ	shield_reduction_off+shield_reduction_len
sideshot_off			equ	shipdead_off+shipdead_len
smartbomb_upgrade_off	equ	sideshot_off+sideshot_len
smartbomb_fire_off		equ	smartbomb_upgrade_off+smartbomb_upgrade_len

maptile_x		equ		12			; tiles on screen (x)
maptile_y		equ		7			; tiles on screen (y)

tileset_x		equ		10			; tiles per row in tileset
tileset_y		equ		63			; tiles per column in tileset

mapwidth		equ		14			; tiles in map (x)
mapheight		equ		659			; tiles in map (y)		

max_enemies1	equ		8
max_enemies2	equ		8
max_enemies3	equ		8
max_enemies4	equ		1
max_enemies5	equ		8
max_enemies6	equ		8

max_bullets		equ		50	; max number of bullet objects on screen
bullet_reload	equ		12

all_enemies		equ		max_enemies1+max_enemies2+max_enemies3+max_enemies4+max_enemies5+max_enemies6


objs			equ 	(maptile_x*maptile_y)+all_enemies+max_bullets+32

ob_list		equ		$200000-$4000
ob_list1	equ		ob_list+$2000

;ob_list         equ     $100000+(1024*900)      	; the object list in use
;ob_list1        equ     $100000+(1024*950)		; the shadow object list

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; bullet offsets
;;

bullet_obj		equ 0
bullet_use		equ 4
bullet_x		equ 8
bullet_y		equ 12
bullet_xadd		equ 16
bullet_yadd		equ 20


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Thread offsets
;;

thread_ptr		equ	0
thread_wavetab	equ	4
thread_active	equ	8
thread_init		equ	12
thread_counter	equ	16
thread_ecounter	equ	20
thread_etype	equ 24
thread_reset	equ 28

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; wave offsets
;;

wave_trigline	equ	0
wave_enemycount	equ	4
wave_unique		equ 8
wave_initdelay	equ 12
wave_enemytype	equ	16
wave_trackdata	equ	20
wave_null1st	equ	80			; offset to 1st null (for additional data)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Boss wave offsets
;;

boss_trigline	equ	0
boss_flag		equ	4
boss_pointer	equ 8
boss_killt0		equ 12
boss_killt1		equ	16
boss_killt2		equ	20
boss_killt3		equ	24	
boss_killt4		equ	28		
boss_patterns	equ	40
boss_deathproc	equ	44
boss_active		equ	48
boss_sampletrig	equ	52



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Enemy Creation offsets
;;

etype_gfxptr	equ	0
etype_thread	equ 4
etype_offset	equ 8
etype_phase		equ 12			; unused
etype_mainanim	equ 16
etype_fireanim	equ	20
etype_killframe	equ	24
etype_deadframe	equ	28
etype_shootfrm	equ	32
etype_1stfire	equ	36
etype_bullgen	equ	40
etype_animloop	equ	44
etype_bulltype	equ 48			; unused (always 10)
etype_bxoff		equ	52
etype_byoff		equ	56
etype_xcent		equ	60
etype_ycent		equ	64
etype_xkill		equ	68
etype_ykill		equ	72
etype_vuln		equ	76			; unused
etype_tilldead	equ	80
etype_bytes_nf	equ	84
etype_animspd	equ 88
etype_playdmg	equ	92
etype_pallette	equ	96
etype_pallbank	equ	100
etype_hitframe	equ	104
etype_bulldmg	equ	108
etype_loopdelay	equ	112
etype_movedead	equ	116
etype_score		equ 120
etype_1stframe	equ	124

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Enemy offsets
;; (Used by wavethreads)
;;

enemy_use		equ	0
enemy_obj		equ 4
enemy_curframe	equ	8
enemy_x			equ 12
enemy_y			equ	16
enemy_tildead	equ	20
enemy_waveptr	equ 24
enemy_initdelay	equ	28
enemy_action	equ	32		; 0-normal, 1-firing, 2-exploding
enemy_animspd	equ	36
enemy_action2	equ	40		; shadow for action (so can fire when hit)
enemy_shooting	equ 44



