;;
;; GPU Smartbomb
;;

GPU_smartbomb:
			movei	#sbomb_type,r19
			movei	#.smartbomb_common,r31
			movei	#.its_dead_now,r21
			load	(r19),r19
			movei	#.check_loop,r29
			movei	#.next_check,r28

.chk_thread1:			
			movei	#thread1,r14
			movei	#.chk_thread2,r30
			jump	(r31)
			nop
.chk_thread2:
			movei	#thread2,r14
			movei	#.chk_thread3,r30
			jump	(r31)
			nop
.chk_thread3:
			movei	#thread3,r14
			movei	#.chk_thread5,r30
			jump	(r31)
			nop
.chk_thread5:
			movei	#thread5,r14
			movei	#.chk_thread6,r30
			jump	(r31)
			nop
.chk_thread6:
			movei	#thread6,r14
			movei	#stop_gpu,r30
			jump	(r31)
			nop

.smartbomb_common:
			load	(r14+(thread_active/4)),r1
			cmpq	#1,r1
			jump	NE,(r30)						; exit if thread inactive

			load	(r14+(thread_etype/4)),r1		; enemy type
			movei	#enemy_lookup,r15
			shlq	#2,r1
			moveq	#16,r27							; 16 enemies per wave
			load	(r15+r1),r15					; pointer to enemy type base

			load	(r14),r14
			
			movei	#map_x_pos,r25
			
			load	(r15+(etype_xcent/4)),r1		; center
			load	(r15+(etype_ycent/4)),r2		; center
			
			loadw	(r25),r25						; map X (left)
			movei	#320,r26
			add		r26,r26							; map X (right)
			movei	#32,r23							; map y (top)
			movei	#256,r24						; map t (bottom)
			
.check_loop:
			load	(r14+(enemy_action/4)),r3
			load	(r14+(enemy_use/4)),r4
			cmpq	#9,r3							; already dead?
			jump	EQ,(r28)
			cmpq	#1,r4							; in use?
			jump	NE,(r28)
			nop
			
			cmpq	#1,r19
			jump	EQ,(r21)						; if killall bomb then kill it
			
			load	(r14+(enemy_x/4)),r3			; object x
			load	(r14+(enemy_y/4)),r4			; object y
			add		r1,r3
			add		r2,r4
			
			cmp		r4,r23
			jump	CC,(r28)						; above screen
			cmp		r4,r24
			jump	CS,(r28)						; below screen
			cmp		r3,r25
			jump	CC,(r28)						; off left
			cmp		r3,r26
			jump	CS,(r28)						; off right
			
;; ok, so its (a) alive, (b) not exploding already and (c) on screen

			load	(r14+(enemy_tildead/4)),r3
			subq	#8,r3
			jr		MI,.its_dead_now
			store	r3,(r14+(enemy_tildead/4))
			moveq	#7,r4
			store	r4,(r14+(enemy_action2/4))		; mark it as hit
			jump	(r28)
			nop

.its_dead_now:
			movei	#scorebuf,r3
			load	(r15+(etype_score/4)),r4
			load	(r3),r5
			store	r4,(r5)
			addq	#4,r5
			store	r5,(r3)

			movei	#smartbomb_sfx_trigger,r4
			
			moveq	#2,r5
			store	r5,(r14+(enemy_action/4))		; mark as destroyed
			store	r5,(r4)							; trigger explosion
			
.next_check:
			addq	#32,r14							; next enemy
			addq	#32,r14
			subq	#1,r27
			jump	ne,(r29)
			nop
			jump	(r30)							; RTS
			nop
			
			.phrase
sbomb_type:	dc.l	0


			

			
			
			
			
			
			
			
			
			
			
			
			
			
			
